## freefem++ 4.13+dfsg

=== 3rdparty/ff-petsc/Makefile ===
# ======================================================================
# Laboratoire Jacques-Louis Lions
# Université Pierre et Marie Curie-Paris6, UMR 7598, Paris, F-75005 France
# http://www.ljll.math.upmc.fr/lehyaric
# ======================================================================
# This file is part of Freefem++
#
# Freefem++ is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Freefem++ is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with Freefem++; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
# ======================================================================
# headeralh default=0 freefem make multipleauthors start=19/03/10 upmc

include Makefile.inc

PYTHON ?=

DIR_INSTALL_REAL:=$(FF_prefix_petsc)/r
DIR_INSTALL_COMPLEX:=$(FF_prefix_petsc)/c
VERSION=$(shell grep "'petsc-" ../getall | perl -pe '($$_)=/([0-9]+([.][0-9]+)+)/')
PACKAGE=../pkg/petsc-$(VERSION).tar.gz
SRCDIR=petsc-$(VERSION)
PETSC_DIR:=$(shell pwd)/$(SRCDIR)

W_SUDO:=$(SHELL mkdir -p "$(DESTDIR)$(FF_prefix_petsc)" && test -w "$(DESTDIR)$(FF_prefix_petsc) || echo sudo)
ifeq ($(COMPILE_OPENBLAS),openblas)
PETSC_OPENBLAS := --download-f2cblaslapack
PETSC_OPENBLAS_C := --with-blaslapack-dir=$(DIR_INSTALL_REAL)
else
PETSC_OPENBLAS = --with-blaslapack-include='$(shell echo $(BLASINC) | sed "s/-I//g")' \
		--with-blaslapack-lib='$(BLAS_LAPACK_LIBS)'
PETSC_OPENBLAS_C = $(PETSC_OPENBLAS)
endif
PETSC_DOWNLOAD_C := --with-metis-dir=$(DIR_INSTALL_REAL) \
		--with-ptscotch-dir=$(DIR_INSTALL_REAL) \
		--with-superlu-dir=$(DIR_INSTALL_REAL) \
		--with-suitesparse-dir=$(DIR_INSTALL_REAL) \
		--with-parmetis-dir=$(DIR_INSTALL_REAL) \
		--with-tetgen-dir=$(DIR_INSTALL_REAL)
PETSC_DOWNLOAD := --download-metis --download-ptscotch \
		--download-hypre --download-parmetis \
		--download-superlu --download-suitesparse --download-tetgen
ifneq ($(TOOL_DYLIB_mmg),)
PETSC_DOWNLOAD += --download-mmg
PETSC_DOWNLOAD_C += --with-mmg-dir=$(DIR_INSTALL_REAL)
ifneq ($(TOOL_DYLIB_parmmg),)
PETSC_DOWNLOAD += --download-parmmg
PETSC_DOWNLOAD_C += --with-parmmg-dir=$(DIR_INSTALL_REAL)
endif
endif
ifeq ($(FFCMAKE),no)
PETSC_DOWNLOAD := $(PETSC_DOWNLOAD) --download-cmake
endif
PETSC_DOWNLOAD_C := $(PETSC_DOWNLOAD_C) --download-htool --download-htool-commit=946875d79d0036afb4dc2c0c13c165a607d830df
ifeq ($(FF_generic_petsc), yes)
FLAGS_MTUNE := -mtune=generic
else
FLAGS_MTUNE := -mtune=native
endif
unexport MAKEFLAGS
COMMON_FLAGS := --with-debugging=0 COPTFLAGS='-O3 $(FLAGS_MTUNE)' CXXOPTFLAGS='-O3 $(FLAGS_MTUNE)' FOPTFLAGS='-O3 $(FLAGS_MTUNE)' --with-ssl=0 --with-x=0 --with-fortran-bindings=0 --with-cudac=0 --with-tau-perfstubs=0 \
		--download-slepc --download-hpddm

ifneq ($(wildcard ~/.petsc_pkg),)
COMMON_FLAGS += --with-packages-download-dir=~/.petsc_pkg
endif

ifeq ($(FC),)
COMMON_FLAGS += --with-fc=0
PETSC_DOWNLOAD += --download-superlu_dist
PETSC_DOWNLOAD_C += --with-superlu_dist-dir=$(DIR_INSTALL_REAL)
endif

ifeq ($(MPICC)$(MPICXX),)
ifeq ($(WIN32DLLTARGET),)
PETSC_DOWNLOAD += --with-cc='$(CC)' --with-cxx='$(CXX)' --download-mpich
PETSC_DOWNLOAD_C += --with-mpi-dir=$(DIR_INSTALL_REAL)
ifneq ($(FC),)
PETSC_DOWNLOAD += --with-fc='$(FC)'
endif
endif
else
COMMON_FLAGS += --with-cc='$(MPICC)' --with-cxx='$(MPICXX)'
ifneq ($(MPIFC),)
COMMON_FLAGS += --with-fc='$(MPIFC)'
endif
endif

ifeq ($(WIN32DLLTARGET),)
ifneq ($(FC),)
ifneq ($(wildcard ~/.petsc_pkg),)
PETSC_DOWNLOAD += --download-slepc-configure-arguments="--download-arpack --with-packages-download-dir=~/.petsc_pkg"
else
PETSC_DOWNLOAD += --download-slepc-configure-arguments="--download-arpack"
endif
endif
endif

ifneq ($(FC),)
ifneq ($(TOOL_DYLIB_scalapack)$(TOOL_DYLIB_mumps),)
PETSC_DOWNLOAD += --download-scalapack --download-mumps
PETSC_DOWNLOAD_C += --with-scalapack-dir=$(DIR_INSTALL_REAL) --with-mumps-dir=$(DIR_INSTALL_REAL)
else
PETSC_DOWNLOAD += --download-superlu_dist
PETSC_DOWNLOAD_C += --with-superlu_dist-dir=$(DIR_INSTALL_REAL)
endif
endif

ifneq ($(WIN32DLLTARGET),)
COMMON_FLAGS += --with-shared-libraries=0 \
	CXXFLAGS='-fno-stack-protector -Wno-stringop-overflow' \
	CFLAGS='-fno-stack-protector -Wno-stringop-overflow' \
	FFLAGS='$(FCFLAGS)' \
	--with-mpiexec='/C/Program\ Files/Microsoft\ MPI/Bin/mpiexec'
ifneq ($(FC),)
ifneq ($(wildcard ~/.petsc_pkg),)
PETSC_DOWNLOAD += '--download-slepc-configure-arguments=--with-packages-build-dir=$(PETSC_DIR)/fr/externalpackages --download-arpack --with-packages-download-dir=~/.petsc_pkg'
else
PETSC_DOWNLOAD += '--download-slepc-configure-arguments=--with-packages-build-dir=$(PETSC_DIR)/fr/externalpackages --download-arpack'
endif
endif
endif

FLAGS_CONF_PETSC_REAL = $(COMMON_FLAGS) --with-scalar-type=real $(PETSC_OPENBLAS) $(PETSC_DOWNLOAD)
FLAGS_CONF_PETSC_COMPLEX = $(COMMON_FLAGS) --with-scalar-type=complex $(PETSC_OPENBLAS_C) $(PETSC_DOWNLOAD_C)

all-local:
	@echo make ..
	@echo " # To build petsc and slepc do $ make petsc-slepc"
	@echo " # warning you have no write acces in $(DESTDIR)$(FF_prefix_petsc)"
	@echo " # need sudo if '$(W_SUDO)' == 'sudo' .."
	@echo " # run under root "
	@echo " # or create / add access to $(DESTDIR)$(FF_prefix_petsc) "
	@echo " # do for examples:"
	@echo " # PETSC_DOWNLOAD = $(PETSC_DOWNLOAD)"
	@echo "	sudo mkdir $(DESTDIR)$(FF_prefix_petsc)"
	@echo "	sudo chown -R $(LOGNAME) $(DESTDIR)$(FF_prefix_petsc)"
	@echo "	make petsc-slepc "

MPI_DIR:=$(shell dirname "$(MPI_INC_DIR)")
W_MPICC:=$(strip $(shell which mpicc))
SUDO_WITH_ENV=$(if $(SUDO), $(SUDO) -E)
ifeq ($(LAPACKLIBS), $(BLASLIBS))
  BLAS_LAPACK_LIBS=$(LAPACKLIBS)
else
  BLAS_LAPACK_LIBS=$(LAPACKLIBS) $(BLASLIBS)
endif

petsc-slepc: Makefile.inc dir-install WHERE-all
recompile: recompile-real recompile-complex
recompile-real:
	-rm */tag-make-real
	-rm */tag-install-real
	make WHERE
recompile-complex:
	-rm */tag-make-complex
	-rm */tag-install-complex
	@if [ -n "$(MPI_INCLUDE)" ]; then $(MAKE) -f Makefile.complex WHERE-complex ;\
	else echo " -- No PETSc, no MPI"; fi

dir-install: Makefile.inc
	-$(SUDO) mkdir -p $(DESTDIR)$(DIR_INSTALL_REAL)
	-$(SUDO) chown ${USER} $(DESTDIR)$(DIR_INSTALL_REAL)
	-$(SUDO) mkdir -p $(DESTDIR)$(DIR_INSTALL_COMPLEX)
	-$(SUDO) chown ${USER} $(DESTDIR)$(DIR_INSTALL_COMPLEX)
	@if test -w 	"$(DESTDIR)$(DIR_INSTALL_REAL)" -a -w 	"$(DESTDIR)$(DIR_INSTALL_COMPLEX)" ; then echo "no need of sudo"; echo > do-sudo; \
	else \
	 echo no write access in $(DESTDIR)$(DIR_INSTALL_REAL) and $(DESTDIR)$(DIR_INSTALL_COMPLEX); \
	 echo " do: make petsc-slepc SUDO=sudo "; \
	 echo " or add write access to 2 directory "; \
	 echo sudo >do-sudo; \
	fi
	test -e "$(DESTDIR)$(DIR_INSTALL_REAL)" -a -e "$(DESTDIR)$(DIR_INSTALL_COMPLEX)"
PETSc-real:
	@if [ -n "$(MPI_INCLUDE)" ]; then $(MAKE) WHERE ;\
	else echo " -- No PETSc, no MPI"; fi

PETSc-complex:
	@if [ -n "$(MPI_INCLUDE)" ]; then $(MAKE) -f Makefile.complex WHERE-complex ;\
	else echo " -- No PETSc, no MPI, no PETSc real"; fi

WHERE:../lib/WHERE.PETSc ../lib/WHERE.SLEPc

../lib/WHERE.PETSc:$(SRCDIR)/tag-install-real
	-mkdir ../lib
	echo 'petsc LD -Wl,-rpath,"$(DIR_INSTALL_REAL)/lib" -L"$(DIR_INSTALL_REAL)/lib" -lpetsc' > $@
	echo 'petsc INCLUDE -I"$(DIR_INSTALL_REAL)/include"' >> $@

$(SRCDIR)/tag-make-real:$(SRCDIR)/tag-conf-real
	cd $(SRCDIR) && $(MAKE) PETSC_DIR=$(PETSC_DIR) PETSC_ARCH=fr all
	touch $@


$(SRCDIR)/tag-install-real :$(SRCDIR)/tag-make-real
	cd $(SRCDIR) && $(MAKE) PETSC_DIR=$(PETSC_DIR) PETSC_ARCH=fr install-lib
	cd $(SRCDIR) && $(MAKE) PETSC_DIR=$(PETSC_DIR) PETSC_ARCH=fr check
	test -e $(DIR_INSTALL_REAL)/include/petsc.h
	test -e $(DIR_INSTALL_REAL)/lib/petsc/conf/petscvariables
	touch $@

Makefile.inc:../../config.status Makefile Makefile-PETSc.inc
	../../config.status --file="Makefile.inc:Makefile-PETSc.inc"

$(SRCDIR)/tag-conf-real:$(SRCDIR)/tag-tar
	cd $(SRCDIR) && $(PYTHON) ./configure --prefix=$(DIR_INSTALL_REAL) \
		$(FLAGS_CONF_PETSC_REAL) PETSC_ARCH=fr
	test -f $(SRCDIR)/fr/lib/petsc/conf/petscvariables
	mkdir -p $(SRCDIR)/fc/externalpackages || true
	cp -r $(SRCDIR)/fr/externalpackages/git.slepc $(SRCDIR)/fr/externalpackages/git.hpddm $(SRCDIR)/fc/externalpackages || true
	touch $@
Make-petsc-download.mk:$(SRCDIR)/tag-install-real
	test -e $(DIR_INSTALL_REAL)/lib/petsc/conf/petscvariables
	egrep 'PETSC_LIB_BASIC|SCALAPACK_|METIS_|MUMPS_|HPDDM_|HTOOL_|TETGEN_|SUPERLU_|MMG_|PTSCOTCH_|SUITESPARSE_' $(DIR_INSTALL_REAL)/lib/petsc/conf/petscvariables | sed 's/-I/ /g'|sort >$@
ifdef 	COMPLEX_CASE
#  version COMPLEX.....
$(SRCDIR)/tag-conf-complex:$(SRCDIR)/tag-tar Make-petsc-download.mk
	cd $(SRCDIR) && $(PYTHON) ./configure --prefix=$(DIR_INSTALL_COMPLEX) \
		$(FLAGS_CONF_PETSC_COMPLEX) PETSC_ARCH=fc
	test -f $(SRCDIR)/fc/lib/petsc/conf/petscvariables
	touch $@

$(SRCDIR)/tag-make-complex:$(SRCDIR)/tag-conf-complex Make-petsc-download.mk
	cd $(SRCDIR) && $(MAKE) PETSC_DIR=$(PETSC_DIR) PETSC_ARCH=fc all
	touch $@

$(SRCDIR)/tag-install-complex :$(SRCDIR)/tag-make-complex
	cd $(SRCDIR) && $(MAKE) PETSC_DIR=$(PETSC_DIR) PETSC_ARCH=fc install-lib
	test -e $(DIR_INSTALL_COMPLEX)/include/petsc.h
	touch $@
WHERE-complex:../lib/WHERE.PETSc-complex ../lib/WHERE.SLEPc-complex

../lib/WHERE.PETSc-complex:$(SRCDIR)/tag-install-complex
	test -e $(DIR_INSTALL_COMPLEX)/include/petsc.h
	-mkdir ../lib
	echo 'petsccomplex LD -Wl,-rpath,"$(DIR_INSTALL_COMPLEX)/lib" -L"$(DIR_INSTALL_COMPLEX)/lib" -lpetsc' > $@
	echo 'petsccomplex INCLUDE -I"$(DIR_INSTALL_COMPLEX)/include"' >> $@
	echo done $@
../lib/WHERE.SLEPc-complex:
	test -e $(DIR_INSTALL_COMPLEX)/include/slepc.h
	-mkdir ../lib
	echo 'slepccomplex LD -Wl,-rpath,"$(DIR_INSTALL_COMPLEX)/lib" -L"$(DIR_INSTALL_COMPLEX)/lib" -lslepc' > $@
	echo 'slepccomplex INCLUDE -I"$(DIR_INSTALL_COMPLEX)/include"' >> $@
	echo done $@

WHERE-all:Makefile WHERE WHERE-complex
	echo >$@
	test -z '$(SCALAPACK_LIB)' || echo scalapack LD $(SCALAPACK_LIB) >>$@
	test -z '$(SCALAPACK_INCLUDE)' || echo scalapack INCLUDE -I$(SCALAPACK_INCLUDE) >>$@
	test -z '$(METIS_LIB)' || echo metis LD $(METIS_LIB) >>$@
	test -z '$(METIS_INCLUDE)' || echo metis INCLUDE -I$(METIS_INCLUDE) >>$@
	test -z '$(MUMPS_LIB)' || echo mumps LD $(MUMPS_LIB) >>$@
	test -z '$(MUMPS_INCLUDE)' || echo mumps INCLUDE -I$(MUMPS_INCLUDE) >>$@
	test -z '$(SUPERLU_LIB)' || echo superlu LD $(SUPERLU_LIB) >>$@
	test -z '$(SUPERLU_INCLUDE)' || echo superlu INCLUDE -I$(SUPERLU_INCLUDE) >>$@
	test -z '$(MMG_LIB)' || echo mmg LD $(MMG_LIB) >>$@
	test -z '$(MMG_INCLUDE)' || echo mmg INCLUDE -I$(MMG_INCLUDE) >>$@
	test -z '$(PARMMG_LIB)' || echo parmmg LD $(PARMMG_LIB) >>$@
	test -z '$(PARMMG_INCLUDE)' || echo parmmg INCLUDE -I$(PARMMG_INCLUDE) >>$@
	test -z '$(PTSCOTCH_LIB)' || echo ptscotch LD $(PTSCOTCH_LIB) >>$@
	test -z '$(PTSCOTCH_INCLUDE)' || echo ptscotch INCLUDE -I$(PTSCOTCH_INCLUDE) >>$@
	test -z '$(TETGEN_LIB)' || echo tetgen LD $(TETGEN_LIB) >>$@
	test -z '$(TETGEN_INCLUDE)' || echo tetgen INCLUDE -I$(TETGEN_INCLUDE) >>$@
	test -z '$(PARMETIS_LIB)' || echo parmetis LD $(PARMETIS_LIB) >>$@
	test -z '$(PARMETIS_INCLUDE)' || echo parmetis INCLUDE -I$(PARMETIS_INCLUDE) >>$@
	test -z '$(HPDDM_LIB)' || echo hpddm LD $(HPDDM_LIB) >>$@
	test -z '$(HPDDM_INCLUDE)' || echo hpddm INCLUDE -I$(HPDDM_INCLUDE) >>$@
	test -z '$(HTOOL_LIB)' || echo htool LD $(HTOOL_LIB) >>$@
	test -z '$(HTOOL_INCLUDE)' || echo htool INCLUDE -I$(HTOOL_INCLUDE) >>$@
	echo 'petsc LD -Wl,-rpath,"$(DIR_INSTALL_REAL)/lib" -L"$(DIR_INSTALL_REAL)/lib" -lpetsc' >>$@
	echo 'petsc INCLUDE -I"$(DIR_INSTALL_REAL)/include"' >>$@

=== 3rdparty/scotch/Makefile ===
# ======================================================================
# Laboratoire Jacques-Louis Lions
# Université Pierre et Marie Curie-Paris6, UMR 7598, Paris, F-75005 France
# http://www.ljll.math.upmc.fr/lehyaric
# ======================================================================
# This file is part of Freefem++
# 
# Freefem++ is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
# 
# Freefem++ is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with Freefem++; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
# ======================================================================
# headeralh default=0 freefem make multipleauthors start=19/03/10 upmc

# Downloading and compiling extra libraries
# -----------------------------------------

include Makefile.inc

all-local: scotch

# Downloading and compiling scotch
# -------------------------------
# https://gforge.inria.fr/frs/download.php/file/34099/scotch_6.0.4.tar.gz
# http://gforge.inria.fr/frs/download.php/23391/scotch_5.1.7_esmumps.tar.gz
# Scotch information
DIRPKG=../pkg
SRCDIR=scotch-v$(scotch_VERSION)
PACKAGE=$(DIRPKG)/scotch-v$(scotch_VERSION_LOCAL).tar.gz
SERVER=https://gforge.inria.fr/frs/download.php/file/34099
#https://gforge.inria.fr/frs/download.php/file/34099/scotch_6.0.4.tar.gz
#https://gforge.inria.fr/frs/download.php/23391
INSTALL=../..
scotch_VERSION=6.1.0
scotch_VERSION_LOCAL=6.1.0
#  trick to no in MPI on NOT .. 
NOTESTMPI= test -z "$(CCP)"
scotch: FAIRE

$(SRCDIR)/AFAIRE:
	$(MAKE) install 
	$(NOTESTMPI) || $(MAKE) install-mpi

FAIRE: $(SRCDIR)/FAIT
	$(MAKE)  WHERE
	$(NOTESTMPI) || $(MAKE) WHERE-mpi
	touch FAIRE

Makefile.inc: ../../config.status Makefile-scotch.inc Makefile
	../../config.status  --file="Makefile.inc:Makefile-scotch.inc"

# DCOMMON_TIMING_OLD
# FFCS - 16/1/13 - what was "$(CCP)" used for?
$(SRCDIR)/FAIT: $(SRCDIR) Makefile.inc
	cp Makefile.inc $(SRCDIR)/src
	cd $(SRCDIR)/src && $(MAKE) scotch esmumps
	touch $(SRCDIR)/FAIT
$(SRCDIR)/FAIT-mpi: $(SRCDIR) Makefile.inc
	cp Makefile.inc $(SRCDIR)/src
	cd $(SRCDIR)/src && $(MAKE) -j1 ptscotch ptesmumps 
	touch $(SRCDIR)/FAIT-mpi

install:$(SRCDIR)/FAIT
	mkdir -p $(SRCDIR)/$(INSTALL)/include/scotch
	cp $(SRCDIR)/include/*.h $(SRCDIR)/$(INSTALL)/include/scotch/
	cp $(SRCDIR)/lib/*.a $(SRCDIR)/$(INSTALL)/lib/
install-mpi:$(SRCDIR)/FAIT-mpi
	mkdir -p $(SRCDIR)/$(INSTALL)/include/scotch
	cp $(SRCDIR)/include/*.h $(SRCDIR)/$(INSTALL)/include/scotch/
	cp $(SRCDIR)/lib/*.a $(SRCDIR)/$(INSTALL)/lib/

# ALH - 16/1/13 - simplifying make rules
WHERE:$(SRCDIR)/FAIT
	$(MAKE) install
	-rm $(SRCDIR)/$(INSTALL)/lib/WHERE.scotch
	echo scotch LD -L@DIR@/lib  -lesmumps -lscotch -lscotcherr >>$(SRCDIR)/$(INSTALL)/lib/WHERE.scotch
#	echo scotchmetis LD -L@DIR@/lib  -lscotchmetis >>$(SRCDIR)/$(INSTALL)/lib/WHERE.scotch
	echo scotch INCLUDE -I@DIR@/include/scotch >> $(SRCDIR)/$(INSTALL)/lib/WHERE.scotch
WHERE-mpi:$(SRCDIR)/FAIT-mpi
	$(MAKE) install-mpi
	-rm $(SRCDIR)/$(INSTALL)/lib/WHERE.scotch
	echo ptscotch LD -L@DIR@/lib  -lesmumps -lptscotch -lptscotcherr >>$(SRCDIR)/$(INSTALL)/lib/WHERE.scotch
#	echo ptscotchparmetis  LD -L@DIR@/lib  -lesmumps -lptscotchparmetis >>$(SRCDIR)/$(INSTALL)/lib/WHERE.scotch
	echo ptscotch INCLUDE -I@DIR@/include/scotch >> $(SRCDIR)/$(INSTALL)/lib/WHERE.scotch
	echo scotch LD -L@DIR@/lib  -lesmumps -lscotch -lscotcherr >>$(SRCDIR)/$(INSTALL)/lib/WHERE.scotch
#	echo scotchmetis LD -L@DIR@/lib  -lscotchmetis >>$(SRCDIR)/$(INSTALL)/lib/WHERE.scotch
	echo scotch INCLUDE -I@DIR@/include/scotch >> $(SRCDIR)/$(INSTALL)/lib/WHERE.scotch

$(SRCDIR): $(PACKAGE)
	tar xzf $(PACKAGE)
	touch $(SRCDIR)

$(PACKAGE):
	../getall -o Scotch -a

# FFCS - 28/3/13 - more cleaning
clean-local:
	-cd $(SRCDIR)/src && $(MAKE)  realclean  -C $(SRCDIR)/src
	-rm config.log
	-rm -rf ../include/scotch/
	-rm -rf ../lib/*scotch*
# FH 	-rm $(PACKAGE) 

clean: clean-local
	-rm Makefile.inc
	-rm -rf $(SRCDIR)
	-rm FAIRE 
.PHONY:$(SRCDIR)/$(INSTALL)

# Local Variables:
# mode:makefile
# ispell-local-dictionary:"british"
# coding:utf-8
# End:

=== examples/bamg/Makefile ===
BAMG=../../../src/bamg/bamg
check:
	cd square;bamg=$(BAMG);export bamg;./dotest
	cd square;bamg=$(BAMG);export bamg;./dotest -q
	cd square;bamg=$(BAMG);export bamg;./doadapt
	cd test;bamg=$(BAMG);perl ./dotest.pl

=== examples/eigen/CMakeLists.txt ===
FILE(GLOB EDP_FILES *.edp)

IF(NOT FREEFEM_MSH3_INSTALLED)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/eigen/Lap3dEigenValue.edp)
ENDIF(NOT FREEFEM_MSH3_INSTALLED)

IF(NOT FREEFEM_LAPACK_INSTALLED)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/eigen/LapnosymComplexEigenValue.edp)
ENDIF(NOT FREEFEM_LAPACK_INSTALLED)


FOREACH(EDP_FILE ${EDP_FILES})
  GET_FILENAME_COMPONENT(FILENAME ${EDP_FILE} NAME_WE)
  ADD_TEST(NAME ${FILENAME} COMMAND "${CMAKE_BINARY_DIR}/src/FreeFem++" ${EDP_FILE}
                            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/examples/eigen)
ENDFOREACH(EDP_FILE)

=== examples/ffddm/CMakeLists.txt ===
FILE(GLOB EDP_FILES *.edp)

IF(NOT FF_PLUGIN_MEDIT)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_CURRENT_SOURCE_DIR}/Helmholtz-2d-HPDDM-BGMRES.edp
                             ${CMAKE_CURRENT_SOURCE_DIR}/elasticity-3d-thirdlevelgeneo.edp
                             ${CMAKE_CURRENT_SOURCE_DIR}/Helmholtz-3d-simple.edp
                             ${CMAKE_CURRENT_SOURCE_DIR}/Navier-2d-marmousi2.edp
                             ${CMAKE_CURRENT_SOURCE_DIR}/diffusion-2d-thirdlevelgeneo.edp
                             ${CMAKE_CURRENT_SOURCE_DIR}/Helmholtz-3d-overthrust.edp
                             ${CMAKE_CURRENT_SOURCE_DIR}/diffusion-3d-simple.edp
                             ${CMAKE_CURRENT_SOURCE_DIR}/natural_convection.edp
                             ${CMAKE_CURRENT_SOURCE_DIR}/Richards-2d.edp
                             ${CMAKE_CURRENT_SOURCE_DIR}/Helmholtz-2d-simple.edp
                             ${CMAKE_CURRENT_SOURCE_DIR}/diffusion-3d-minimal-ddm.edp
                             ${CMAKE_CURRENT_SOURCE_DIR}/natural_convection_3D_obstacle.edp
                             ${CMAKE_CURRENT_SOURCE_DIR}/diffusion-3d-minimal-direct.edp
                             ${CMAKE_CURRENT_SOURCE_DIR}/Helmholtz-2d-marmousi.edp
                             ${CMAKE_CURRENT_SOURCE_DIR}/elasticity-3d-simple.edp)
ENDIF(NOT FF_PLUGIN_MEDIT)

IF(NOT FF_PLUGIN_ELEMENT_MIXTE3D)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_CURRENT_SOURCE_DIR}/Maxwell-3d-simple.edp)
ENDIF(NOT FF_PLUGIN_ELEMENT_MIXTE3D)

IF(NOT FF_PLUGIN_METIS)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_CURRENT_SOURCE_DIR}/Maxwell_Cobracavity.edp)
ENDIF(NOT FF_PLUGIN_METIS)

FOREACH(EDP_FILE ${EDP_FILES})
  GET_FILENAME_COMPONENT(FILENAME ${EDP_FILE} NAME_WE)
  ADD_TEST(NAME ${FILENAME} COMMAND ${CMAKE_BINARY_DIR}/src/FreeFem++ ${EDP_FILE}
                            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/examples/ffddm)
ENDFOREACH(EDP_FILE)

=== examples/mpi/CMakeLists.txt ===
# TODO: remove this line as soon as autoconf is removed (only here for config.h and config-wrapper.h)
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}) 

 
IF(MPI_FOUND)

#  FILE(GLOB CPPFILES *.cpp)
#
#  LIST(REMOVE_ITEM CPPFILES ${CMAKE_SOURCE_DIR}/examples++-mpi/example-mumps.cpp
#                            ${CMAKE_SOURCE_DIR}/examples++-mpi/mpi-cmaes.cpp
#                            ${CMAKE_SOURCE_DIR}/examples++-mpi/MUMPS.cpp
#                            ${CMAKE_SOURCE_DIR}/examples++-mpi/MUMPS_FreeFem.cpp
#                            ${CMAKE_SOURCE_DIR}/examples++-mpi/parmetis.cpp)
#
#  FOREACH(CPPFILE ${CPPFILES})
#    GET_FILENAME_COMPONENT(FILENAME ${CPPFILE} NAME_WE)
#    ADD_LIBRARY(${FILENAME} MODULE ${CPPFILE})
#    TARGET_LINK_LIBRARIES(${FILENAME} ${MPI_CXX_LIBRARIES})
#    INCLUDE_DIRECTORIES(${MPI_CXX_INCLUDE_PATH} 
#                        ${CMAKE_SOURCE_DIR}/src/bamglib
#                        ${CMAKE_SOURCE_DIR}/src/Graphics
#                        ${CMAKE_SOURCE_DIR}/src/femlib
#                        ${CMAKE_SOURCE_DIR}/src/fflib)
#    SET_TARGET_PROPERTIES(${FILENAME} PROPERTIES PREFIX "")
#  ENDFOREACH(CPPFILE)

#  IF(PARMETIS_FOUND)
#    ADD_LIBRARY(parmetis MODULE parmetis.cpp)
#    TARGET_LINK_LIBRARIES(parmetis ${MPI_CXX_LIBRARIES})
#    INCLUDE_DIRECTORIES(${MPI_CXX_INCLUDE_PATH} 
#                        ${CMAKE_SOURCE_DIR}/src/bamglib
#                        ${CMAKE_SOURCE_DIR}/src/Graphics
#                        ${CMAKE_SOURCE_DIR}/src/femlib
#                        ${CMAKE_SOURCE_DIR}/src/fflib)
#    SET_TARGET_PROPERTIES(parmetis PROPERTIES PREFIX "")
#  ENDIF(PARMETIS_FOUND) 

FILE(GLOB EDP_FILES *.edp)

# tests which are known to fail are removed from test list  
LIST(REMOVE_ITEM EDP_FILES ${CMAKE_CURRENT_SOURCE_DIR}/chaleur3D-mumps.edp
                           ${CMAKE_CURRENT_SOURCE_DIR}/essai-com.edp
                           ${CMAKE_CURRENT_SOURCE_DIR}/schwarz-2d.edp
                           ${CMAKE_CURRENT_SOURCE_DIR}/schwarz-b.edp
                           ${CMAKE_CURRENT_SOURCE_DIR}/schwarz-c.edp)


IF(NOT EXISTS $ENV{FF_INCLUDEPATH}/getARGV.idp OR NOT FF_PLUGIN_MUMPS)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/mpi/NSCaraCyl.edp)
ENDIF(NOT EXISTS $ENV{FF_INCLUDEPATH}/getARGV.idp OR NOT FF_PLUGIN_MUMPS)
  
IF(NOT EXISTS $ENV{FF_INCLUDEPATH}/getARGV.idp OR NOT FF_PLUGIN_METIS)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/mpi/parmetis.edp)
ENDIF(NOT EXISTS $ENV{FF_INCLUDEPATH}/getARGV.idp OR NOT FF_PLUGIN_METIS)
  

IF(NOT EXISTS $ENV{FF_INCLUDEPATH}/getARGV.idp OR NOT FF_PLUGIN_MSH3)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/mpi/parmetis-3d.edp)
ENDIF(NOT EXISTS $ENV{FF_INCLUDEPATH}/getARGV.idp OR NOT FF_PLUGIN_MSH3)
  


IF(NOT EXISTS $ENV{FF_INCLUDEPATH}/mortar-msh.idp)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/mpi/mortar-DN-4-mpi.edp)
ENDIF(NOT EXISTS $ENV{FF_INCLUDEPATH}/mortar-msh.idp)
  



IF (NOT FF_PLUGIN_MPICG)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/mpi/DDM-Schwarz-Lame-2d.edp
                             ${CMAKE_SOURCE_DIR}/examples/mpi/DDM-Schwarz-Lame-3d.edp
                             ${CMAKE_SOURCE_DIR}/examples/mpi/DDM-Schwarz-Lap-2dd.edp
                             ${CMAKE_SOURCE_DIR}/examples/mpi/DDM-Schwarz-Lap-3d.edp
                             ${CMAKE_SOURCE_DIR}/examples/mpi/DDM-Schwarz-Stokes-2d.edp
                             ${CMAKE_SOURCE_DIR}/examples/mpi/MPICGLap.edp
                             ${CMAKE_SOURCE_DIR}/examples/mpi/MPIGMRES2D.edp
                             ${CMAKE_SOURCE_DIR}/examples/mpi/MPIGMRES3D.edp)
ENDIF(NOT FF_PLUGIN_MPICG)


IF (NOT FF_PLUGIN_MUMPS)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/mpi/LapMPIEigenValue.edp
                             ${CMAKE_SOURCE_DIR}/examples/mpi/testsolver_MUMPS.edp
                             ${CMAKE_SOURCE_DIR}/examples/mpi/MUMPS.edp
                             ${CMAKE_SOURCE_DIR}/examples/mpi/VG.edp
                             ${CMAKE_SOURCE_DIR}/examples/mpi/cavityNewtow-MUMPS.edp)
ENDIF(NOT FF_PLUGIN_MUMPS)


IF (NOT FF_PLUGIN_MEDIT)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/mpi/LaplaceRT-3d-matrix-mumps.edp)
ENDIF(NOT FF_PLUGIN_MEDIT)

IF (NOT FF_PLUGIN_MPI_CMAES)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/mpi/cmaes-mpi-VarIneq.edp)
ENDIF(NOT FF_PLUGIN_MPI_CMAES)


IF (NOT FF_PLUGIN_MSH3)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/mpi/NSI3d-carac-mumps.edp
                             ${CMAKE_SOURCE_DIR}/examples/mpi/Stokes-v1-matrix-mumps.edp
                             ${CMAKE_SOURCE_DIR}/examples/mpi/Stokes-v2-matrix-mumps.edp
                             ${CMAKE_SOURCE_DIR}/examples/mpi/Stokes-v3-matrix-mumps.edp
                             ${CMAKE_SOURCE_DIR}/examples/mpi/schwarz-3.edp)
ENDIF(NOT FF_PLUGIN_MSH3)

if(${CMAKE_VERSION} VERSION_LESS "10.0.0")
  set(FF_MPIEXEC ${MPIEXEC})
else()
  set(FF_MPIEXEC ${MPIEXEC_EXECUTABLE})
endif(${CMAKE_VERSION} VERSION_LESS "10.0.0")

IF(NOT MPIEXEC_MAX_NUMPROCS EQUAL 4)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/mpi/mortar-DN-4-mpi.edp)

  ADD_TEST(NAME mortar-DN-4-mpi COMMAND ${FF_MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 
  ${MPIEXEC_PREFLAGS} ${CMAKE_BINARY_DIR}/src/FreeFem++-mpi ${MPIEXEC_POSTFLAGS} -nw mortar-DN-4-mpi.edp
                            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/examples/mpi)

ENDIF(NOT MPIEXEC_MAX_NUMPROCS EQUAL 4)

FOREACH(EDP_FILE ${EDP_FILES})
  GET_FILENAME_COMPONENT(FILENAME ${EDP_FILE} NAME_WE)

  ADD_TEST(NAME ${FILENAME} COMMAND ${FF_MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} ${MPIEXEC_MAX_NUMPROCS} 
  ${MPIEXEC_PREFLAGS} ${CMAKE_BINARY_DIR}/src/FreeFem++-mpi ${MPIEXEC_POSTFLAGS} -nw ${EDP_FILE}
                            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/examples/mpi)
ENDFOREACH(EDP_FILE)




ENDIF(MPI_FOUND)

=== src/bamg/CMakeLists.txt ===

ADD_EXECUTABLE(bamg ${CMAKE_SOURCE_DIR}/src/bamg/bamg.cpp 
                    ${CMAKE_SOURCE_DIR}/src/bamg/global.cpp) 

TARGET_LINK_LIBRARIES(bamg libff bamglib)

INSTALL(TARGETS bamg
        RUNTIME DESTINATION bin)  


ADD_EXECUTABLE(cvmsh2 ${CMAKE_SOURCE_DIR}/src/bamg/cvmsh2.cpp 
                      ${CMAKE_SOURCE_DIR}/src/bamg/global.cpp)

TARGET_LINK_LIBRARIES(cvmsh2 bamglib libff)

INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR} 
                    ${CMAKE_SOURCE_DIR}/src/bamg 
                    ${CMAKE_SOURCE_DIR}/src/bamglib 
                    ${CMAKE_SOURCE_DIR}/src/femlib 
                    ${CMAKE_SOURCE_DIR}/src/fflib 
                    ${CMAKE_SOURCE_DIR}/src/Graphics)

INSTALL(TARGETS cvmsh2
        RUNTIME DESTINATION bin)

=== src/fflib/CMakeLists.txt ===
include(ff_define_libff_library)

ff_define_libff_library()

=== 3rdparty/mshmet/src/Makefile ===
include ../ff-flags

MSHMETDIR =  $(abs_top_builddir)/3rdparty/mshmet/src
# working dirs
EXEDIR = #$(MSHMETDIR)/executable
SRCDIR = $(MSHMETDIR)/sourceslib
OBJDIR = $(MSHMETDIR)/objects/$(ARCHI)
ARCDIR = $(MSHMETDIR)/archives
DIRDIR = $(EXEDIR) $(OBJDIR) $(ARCDIR)
VPATH  = $(SRCDIR)
INCDIR = -I$(MSHMETDIR)/sourceslib/ -I$(abs_top_builddir)/src/libMesh/
LDLDIR = -L$(abs_top_builddir)/src/libMesh/ -lMesh

# objects list
src    = $(wildcard $(SRCDIR)/*.c)
header = $(wildcard $(SRCDIR)/*.h)
objs   = $(patsubst $(SRCDIR)%,$(OBJDIR)%,$(src:.c=.o))
prog   = mshmet
lib    = $(OBJDIR)/libmshmet.a

#.SILENT:

$(OBJDIR)/%.o: $(SRCDIR)/%.c
	$(CC) $(OPT64) $(INCDIR) $(CFLAGS) -DSERIAL -c $< -o $@

$(EXEDIR)/$(prog):$(DIRDIR) $(objs)
	echo "#define COMPIL " '"' `date` '"' > $(SRCDIR)/compil.date
	#$(CC) -c $(CFLAGS) $(INCDIR) $(SRCDIR)/mshmet.c -o $(OBJDIR)/mshmet.o
	#$(CC) $(LDFLAGS) $(OPT64) $(LDLDIR) $(objs) -o $@ -lm
	$(AR) $(ARFLAGS) $(lib) $(objs)
	$(RANLIB) $(lib)
$(SRCDIR)/mshmetlib.c:$(SRCDIR)/compil.date

$(SRCDIR)/compil.date:	
	echo "#define COMPIL " '"' `date` '"' > $(SRCDIR)/compil.date
	
$(objs):$(header)

$(DIRDIR):
	@[ -d $@ ] || mkdir $@

clean:
	-rm $(objs) $(EXEDIR)/$(prog)


target: $(EXEDIR)/$(prog)

=== cmake/modules/mumps/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

PROJECT(mumps C Fortran)

FIND_PACKAGE(MPI REQUIRED)

SET(C_FLAGS ${CMAKE_C_FLAGS})


FILE(GLOB C_FILES ${CMAKE_SOURCE_DIR}/src/*.c)
FILE(GLOB FORTRAN_FILES ${CMAKE_SOURCE_DIR}/src/*.F)

INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/include ${CMAKE_SOURCE_DIR}/src ${MPI_Fortran_INCLUDE_PATH})

SET(CMAKE_C_FLAGS "${C_FLAGS} -D MUMPS_ARITH=MUMPS_ARITH_s")
ADD_LIBRARY(smumps ${C_FILES} ${FORTRAN_FILES})

SET(CMAKE_C_FLAGS "${C_FLAGS} -D MUMPS_ARITH=MUMPS_ARITH_d")
ADD_LIBRARY(dmumps ${C_FILES} ${FORTRAN_FILES})

SET(CMAKE_C_FLAGS "${C_FLAGS} -D MUMPS_ARITH=MUMPS_ARITH_c")
ADD_LIBRARY(cmumps ${C_FILES} ${FORTRAN_FILES})

SET(CMAKE_C_FLAGS "${C_FLAGS} -D MUMPS_ARITH=MUMPS_ARITH_z")
ADD_LIBRARY(zmumps ${C_FILES} ${FORTRAN_FILES})

=== cmake/modules/suitesparse/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.7)

PROJECT(suitesparse C)

ADD_DEFINITIONS(-O3)

FILE(GLOB UMFPACK_FILES UMFPACK/Source/*.c)
ADD_LIBRARY(umfpack SHARED ${UMFPACK_FILES})
TARGET_INCLUDE_DIRECTORIES(umfpack PRIVATE UMFPACK/Source 
                                           UMFPACK/Include
                                           AMD/Include
                                           SuiteSparse_config
                                           CHOLMOD/Include)

=== debian/changelog ===
freefem++ (4.13+dfsg-1build5) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 05:21:19 +0000

freefem++ (4.13+dfsg-1build4) noble; urgency=medium

  * No-change rebuild against libarpack2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 07:33:07 +0000

freefem++ (4.13+dfsg-1build3) noble; urgency=medium

  * Rebuild against new libcholmod5.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 23 Nov 2023 17:50:01 +0100

freefem++ (4.13+dfsg-1build2) mantic; urgency=medium

  * No-change rebuild against

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 15 Aug 2023 21:10:52 +0000

freefem++ (4.13+dfsg-1build1) mantic; urgency=medium

  * No-change rebuild against libcholmod4

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 30 Jul 2023 21:14:05 +0000

freefem++ (4.13+dfsg-1) unstable; urgency=medium

  [Debian Janitor]
  * Remove constraints unnecessary since buster:
    + Build-Depends: Drop versioned constraint on libscalapack-mpi-dev.

  [Francois Mazen]
  * New upstream version 4.13
  * Remove obsolete patches
  * Add patch to remove obsolete binary_function and unary_function,
    and fix failing autopkgtest (Closes: #1033702)
  * Remove allow-stderr restriction for build-and-run-lib autopkgtest,
    because not necessary anymore due to above patch
  * Bump standard version to 4.6.2

 -- Francois Mazen <francois@mzf.fr>  Sat, 17 Jun 2023 16:45:34 +0200

=== debian/control ===
Source: freefem++
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>,
           Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>,
           Francois Mazen <francois@mzf.fr>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libsuperlu-dev,
               gawk,
               gfortran,
               rdfind,
               symlinks,
               libhdf5-dev,
               flex,
               bison,
               libxt-dev,
               libxext-dev,
               libxxf86vm-dev,
               libxpm-dev,
               libmumps-scotch-dev,
               libmumps-ptscotch-dev,
               libfltk1.3-dev,
               freeglut3-dev,
               ghostscript,
               imagemagick,
               texlive,
               texlive-extra-utils,
               texlive-latex-extra,
               texlive-font-utils,
               libfftw3-dev,
               libgsl-dev,
               libhypre-dev,
               libarpack2-dev,
               libsuitesparse-dev,
               libmumps-dev,
               libscalapack-mpi-dev,
               libscotch-dev,
               libptscotch-dev,
               libmetis-dev,
               libmumps-seq-dev,
               libnlopt-dev,
               coinor-libipopt-dev,
               libgmm++-dev,
               libtet1.5-dev,
               libpetsc-real-dev,
               libpetsc-complex-dev,
               unzip,
               autoconf-archive
# libmmg3dlib4.0-4.0-dev, freeyams, mshmet, mshint,
# libparms2-dev, libitsol-dev,
# libhips-dev, libpastix-dev,
# libsuperlu-dist-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/science-team/freefempp
Vcs-Git: https://salsa.debian.org/science-team/freefempp.git
Homepage: http://www.freefem.org/ff++/
Rules-Requires-Root: no

Package: freefem++
Architecture: any
Section: math
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Provides the binaries of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve.
 .
 This package contains the executables of FreeFem++.

Package: libfreefem++
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Provides the shared libraries of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve.
 .
 This package contains the shared libraries of FreeFem++.

Package: libfreefem++-dev
Architecture: any
Section: libdevel
Depends: libfreefem++,
         ${shlibs:Depends},
         ${misc:Depends}
Description: Provides the development files of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve.
 .
 This package contains the development files of FreeFem++.

Package: freefem++-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Provides the documentation of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve.
 .
 This package contains the documentation files of FreeFem++.

=== debian/tests/control ===
Tests: smoke
Depends: freefem++, expect
Restrictions: superficial

Tests: run-func-example
Depends: freefem++, freefem++-doc, expect

Tests: build-and-run-lib
Depends: libfreefem++-dev, freefem++, build-essential
Architecture: amd64, armhf, i386
